<?php
/*
Plesk Spamdyke Control Panel (Version see version.php) - GUI for Plesk spamdyke implementation

Copyright (C) [2008] [Matthias Hackbarth / www.haggybear.de]

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as 
published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; if not, see <http://www.gnu.org/licenses/>.
*/

/**
 * Klasse zum sammeln der Admin-Rechte Infos der Domain(s)
 */

class AdminRights{
     
     var $regKarten = "'dnsbl_settings','gl_settings','allg_settings','multi_right','report_settings'";

     /** Variable, die die Domain aufnimmt */
     var $dieDomain;

     /** Variable, die alle Rechte aus der Rights.txt aufnimmt */
     var $alleRechte = array();

     var $glFolder;

     var $scriptFolder;

     var $spamdykeFolder;
     
     var $spamdykeFolderConfigDir;
     
     var $spamdykeFolderCustomsDirs = array();

     var $isAllView = false;

     var $otherSettings = array("reject-empty-rdns","reject-missing-sender-mx","reject-unresolvable-rdns","reject-ip-in-cc-rdns");
     
     var $isReportOn;
     
     var $reportStates;
     
     var $abuseDetails;
     
     /**
       * Konstruktor
       *
       */

     function AdminRights($dom,$glDir){

              $this->dieDomain = $dom;
              $this->scriptFolder = str_replace("index.php","",$_SERVER["SCRIPT_FILENAME"]);
              $this->spamdykeFolder = substr($glDir,0,strrpos($glDir,"/"));
              $this->spamdykeFolderConfigDir = substr($glDir,0,strrpos($glDir,"/"))."/conf.";

	      $this->leseRechte();
	      $this->leseAbuseRechte();
	      
	      $this->isReportOn = file_exists("/etc/cron.daily/scp_reports");
	      if($this->isReportOn) $this->leseReportRechte();
     	      
             }
             
     function getDomainRight($recht){
     	
              $select = ($this->alleRechte[$this->dieDomain][$recht])?"selected":"";
	      
	      echo "<select name=\"$recht\">\n";
	      echo "<option value=\"0\">".VALUE_NO."</option>\n";
	      echo "<option value=\"1\" ".$select.">".VALUE_YES."</option>\n";
	      echo "</select>";
              }
              
     function getDomainRightMulti($dom,$recht){
     	
              $select = ($this->alleRechte[$dom][$recht])?"checked":"";
	      
	      $html = '<input type="checkbox" name="'.$dom.'#'.$recht.'" value="domrights" '.$select.'>'; 
	      return $html;
	      }

     function getEventHandler($typ){

              $res = mysql_query("SELECT id FROM event_handlers where command like '%plesk_event_handler.sh%' and command like '%".$typ."%'");
              $select = (mysql_num_rows($res)>0)?"selected":"";
	      
	      echo "<select name=\"$typ\">\n";
	      echo "<option value=\"0\">".VALUE_NO."</option>\n";
	      echo "<option value=\"1\" ".$select.">".VALUE_YES."</option>\n";
	      echo "</select>";
              }

     function setEventHandler($conf,$params){

              @mysql_query("DELETE FROM event_handlers where command like '%plesk_event_handler.sh%'");
              
              if($params["create"]) mysql_query("INSERT INTO event_handlers (action_id, priority, user, command )VALUES ( '21', '50', 'root', '".$this->scriptFolder."plesk_event_handler.sh create ".$conf["graylist-dir"]."/ <new_domain_name>')"); 
	      if($params["delete"]) mysql_query("INSERT INTO event_handlers (action_id, priority, user, command )VALUES ( '23', '50', 'root', '".$this->scriptFolder."plesk_event_handler.sh delete ".$conf["graylist-dir"]."/ <old_domain_name>')"); 
              if($params["update"]) mysql_query("INSERT INTO event_handlers (action_id, priority, user, command )VALUES ( '22', '50', 'root', '".$this->scriptFolder."plesk_event_handler.sh update ".$conf["graylist-dir"]."/ <old_domain_name> <new_domain_name>')"); 
              }

     function updateRechte($recht,$state){
              $this->alleRechte[$this->dieDomain][$recht] = $state;
	      }
	      
     function updateRechteMulti($data){
     	      $this->alleRechte = array();
     	      while (list($key, $val) = each($data)){
     	      	    if($val == "domrights"){
     	      	    	$handler = explode("#",$key);
     	      	    	$this->alleRechte[str_replace("_",".",$handler[0])][$handler[1]] = 1;
     	      	    	}
     	      	    }
     	      $this->schreibeRechte();
     	      }


     function schreibeRechte(){
     	      $write = serialize($this->alleRechte);
	      $openStream = fopen ("rights.txt","w");
	      fwrite($openStream,$write,strlen($write)); 
              fclose($openStream);
              $this->createSpamdykeTree();
              }
              
     function checkSpamdykeTree($dir){
  	      $dirlist = opendir($dir);
  	      
              while ($file = readdir ($dirlist))
              {
                if ($file != '.' && $file != '..')
                {
                  $newpath = $dir.'/'.$file;
                  $level = explode('/',$newpath);
                  if (is_dir($newpath)){
                    $this->checkSpamdykeTree($newpath);
                  }
                  else{
                  
                    $str = str_replace($this->spamdykeFolderConfigDir.'/_recipient_/',"",$newpath);
                    $strArray = explode("/",$str);
                  
                    array_push($this->spamdykeFolderCustomsDirs,implode(".",array_reverse($strArray)));
                  }
                }
              }
              closedir($dirlist);
            }
              
     function createSpamdykeTree(){
     	      $org = $this->alleRechte;
     	      $this->checkSpamdykeTree($this->spamdykeFolderConfigDir.'d/_recipient_');
              $this->checkSpamdykeTree($this->spamdykeFolderConfigDir.'s/_recipient_');
     	      
     	      while (list($key,$val) = each ($org)){
     	      	    $baum[$key] = $val;
     	      	    
     	      	    $res = mysql_query("SELECT a.name FROM psa.domainaliases AS a, psa.domains AS b WHERE b.name = '$key' AND b.id = a.dom_id");
     	      	    while($dat = mysql_fetch_object($res)){
     	      	    	 $baum[$dat->name] = $val;
     	      	         }
     	      	    }
     	     
     	      while (list($key, $val) = each($baum)){

     	      	     $domArray = explode(".",$key);
     	      	     $suffix = (count($domArray)>2)?"s":"d";
     	      	     $writeFile = $this->spamdykeFolderConfigDir.$suffix.'/_recipient_/'.implode("/",array_reverse($domArray));
     	      	     
     	      	   
     	      	     while (list($key2, $val2) = each($val)){
          	      	 $html = "";
       	      	     	 $wList = $this->spamdykeFolder."/whitelist_ip_".implode("_",$domArray);
       	      	     	 $bList = $this->spamdykeFolder."/blacklist_ip_".implode("_",$domArray);	
       	      	     	 $html.="ip-whitelist-file=".$wList."\n";
       	      	     	 $html.="ip-blacklist-file=".$bList."\n";
       	      	     	 if(!file_exists($wList)){
       	      	     	     exec('./wrapper "1" "touch '.$wList.'"');
       	      	     	     }
       	      	     	 if(!file_exists($bList)){
       	      	     	     exec('./wrapper "1" "touch '.$bList.'"');
       	      	     	     }

       	      	     	 $wList = $this->spamdykeFolder."/whitelist_senders_".implode("_",$domArray);
       	      	     	 $bList = $this->spamdykeFolder."/blacklist_senders_".implode("_",$domArray);	
       	      	     	 $html.="sender-whitelist-file=".$wList."\n";
       	      	     	 $html.="sender-blacklist-file=".$bList."\n";
       	      	     	 if(!file_exists($wList)){
       	      	     	     exec('./wrapper "1" "touch '.$wList.'"');
       	      	     	     }
       	      	     	 if(!file_exists($bList)){
       	      	     	     exec('./wrapper "1" "touch '.$bList.'"');
       	      	     	     }
       	      	     	 
       	      	     	 $wList = $this->spamdykeFolder."/whitelist_recipient_".implode("_",$domArray);
       	      	     	 $bList = $this->spamdykeFolder."/blacklist_recipient_".implode("_",$domArray);	
       	      	     	 $html.="recipient-whitelist-file=".$wList."\n";
       	      	     	 $html.="recipient-blacklist-file=".$bList."\n";
       	      	     	 if(!file_exists($wList)){
       	      	     	     exec('./wrapper "1" "touch '.$wList.'"');
       	      	     	     }
       	      	     	 if(!file_exists($bList)){
       	      	     	     exec('./wrapper "1" "touch '.$bList.'"');
       	      	     	     }
       	      	     	     
       	      	     	 $wList = $this->spamdykeFolder."/whitelist_rdns_".implode("_",$domArray);
       	      	     	 $bList = $this->spamdykeFolder."/blacklist_rdns_".implode("_",$domArray);	
       	      	     	 $html.="rdns-whitelist-file=".$wList."\n";
       	      	     	 $html.="rdns-blacklist-file=".$bList."\n";
       	      	     	 if(!file_exists($wList)){
       	      	     	     exec('./wrapper "1" "touch '.$wList.'"');
       	      	     	     }
   	      	     	 if(!file_exists($bList)){
       	      	     	     exec('./wrapper "1" "touch '.$bList.'"');
       	      	     	     }

       	      	     	 $bList = $this->spamdykeFolder."/blacklist_keywords_".implode("_",$domArray);
       	      	     	 $html.="ip-in-rdns-keyword-blacklist-file=".$bList."\n";
       	      	     	 if(!file_exists($bList)){
       	      	     	     exec('./wrapper "1" "touch '.$bList.'"');
       	      	     	     }
     	      	     	      
     	                   
             	   if(!file_exists($writeFile )) exec('./wrapper "1" "mkdir '.substr($writeFile,0,strrpos($writeFile,"/")).'"');
    	           exec('./wrapper "1" "writeconfigdir '.$writeFile.'" "'.$html.'"'); 
     	                   
       	      	   }
       	      	} 	
     	  
     	      }
              
     function leseRechte(){
     	      $file = fopen("rights.txt",'r');
	      $this->alleRechte = unserialize(trim(fread($file,filesize("rights.txt"))));
	      fclose($file);
              }

     function hideMe($width){
              if($this->isAllView) echo "<div id=\"blind\" style=\"width:$width\"></div>";
              }
              
     function leseReportRechte(){
     	      $file = fopen("reports.txt",'r');
	      $this->reportStates = unserialize(trim(fread($file,filesize("reports.txt"))));
	      fclose($file);
     	      }
     	      
     function schreibeReportRechte(){
              $write = serialize($this->reportStates);
	      $openStream = fopen ("reports.txt","w");
	      fwrite($openStream,$write,strlen($write)); 
              fclose($openStream);
     	      }
     	      
     function leseAbuseRechte(){
     	      $file = fopen("abuse.txt",'r');
	      $this->abuseDetails = unserialize(trim(fread($file,filesize("abuse.txt"))));
	      fclose($file);
              if(empty($this->abuseDetails["sender"])) $this->abuseDetails["sender"] = $_SERVER["SERVER_ADMIN"];
     	      }
     	      
     function schreibeAbuseRechte(){
              $write = serialize($this->abuseDetails);
	      $openStream = fopen ("abuse.txt","w");
	      fwrite($openStream,$write,strlen($write)); 
              fclose($openStream);
     	      }

     function setSpamDykeConf($conf,$post){
     	
              while (list($key, $val) = each($conf)){
                     if(!stristr($key,"config-dir")){
                        $confStart[$key] = $val;
                        }
                     }
              $conf = $confStart;
     	
     	      $conf["config-dir"] = $this->spamdykeFolderConfigDir."d";
     	      $conf["config-dirSCPADD"] = $this->spamdykeFolderConfigDir."s";
     	
              $conf["graylist-level"] = $post["graylist-level"];
              if(!empty($post["graylist-min-secs"])){
              	 $conf["graylist-min-secs"] = $post["graylist-min-secs"];
              }else{
                 unset($conf["graylist-min-secs"]);
               }
              if(!empty($post["graylist-max-secs"])){
              	 $conf["graylist-max-secs"] = $post["graylist-max-secs"];
              }else{
                 unset($conf["graylist-max-secs"]);
               }
              if(!empty($post["greeting-delay-secs"])){
              	 $conf["greeting-delay-secs"] = $post["greeting-delay-secs"];
              }else{
                 unset($conf["greeting-delay-secs"]);
               }
              if(!empty($post["connection-timeout-secs"])){
              	 $conf["connection-timeout-secs"] = $post["connection-timeout-secs"];
              }else{
                 unset($conf["connection-timeout-secs"]);
               }
              if(!empty($post["idle-timeout-secs"])){
              	 $conf["idle-timeout-secs"] = $post["idle-timeout-secs"];
              }else{
                 unset($conf["idle-timeout-secs"]);
               }

              while (list($key, $val) = each($conf)){
                     if(!stristr($key,"dns-blacklist-entry") && !stristr($key,"dns-whitelist-entry") && !eregi("(".implode("|",$this->otherSettings).")",$key)){
                        $confNew[$key] = $val;
                        }
                     }
              $conf = $confNew;

              while (list($key, $val) = each($post["dns-blacklist-entry"])){
                     if(!empty($val)){
                        $key = ($post["dns-blacklist-entry-activ"][$key])?"dns-blacklist-entrySCP$key":"#dns-blacklist-entrySCP$key";
                        $conf[$key] = $val;
                        }
                     }
                     
              while (list($key, $val) = each($post["dns-whitelist-entry"])){
                     if(!empty($val)){
                        $key = ($post["dns-whitelist-entry-activ"][$key])?"dns-whitelist-entrySCP$key":"#dns-whitelist-entrySCP$key";
                        $conf[$key] = $val;
                        }
                     }                     

              if(!empty($post["new_dnsbl"])){
                 $conf["dns-blacklist-entrySCPNEW"] = $post["new_dnsbl"];
                }
                
              if(!empty($post["new_dnswl"])){
                 $conf["dns-whitelist-entrySCPNEW"] = $post["new_dnswl"];
                }


              while (list($key, $val) = each($post["conf-others"])){
                     if(!empty($val)){
                        $conf[$val] = "";
                        }
                     }           
              

              while (list($key, $val) = each($conf)){
              	
              	if(!strstr($key,"_MY")){
              	   $key = eregi_replace("SCP(.*)","",$key);
                   $confFile.= (empty($val))?"$key\n":"$key=$val\n";
                   }
        	}

              #echo nl2br($confFile);
              exec('./wrapper "1" "writespamdykeconf '.SPAMDYKE_CONFIG.'" "'.$confFile.'"');

              }

      function getDnsblList($conf){

               $count = 1;
               while (list($key, $val) = each($conf)){
                      if(stristr($key,"dns-blacklist-entry")){
                         $checked = stristr($key,"#")?"":"checked";
                         echo "<tr>";
                         echo "<td>&nbsp;</td>";
                         echo "<td><input type=\"checkbox\" name=\"dns-blacklist-entry-activ[$count]\" value=\"1\" $checked></td>";
                         echo "<td><input type=\"text\" size=\"50\" name=\"dns-blacklist-entry[$count]\" value=\"$val\"></td>";
                         echo "</tr>";
                         $count++;
                         }
                      }
               }
               
      function getDnswlList($conf){

               $count = 1;
               while (list($key, $val) = each($conf)){
                      if(stristr($key,"dns-whitelist-entry")){
                         $checked = stristr($key,"#")?"":"checked";
                         echo "<tr>";
                         echo "<td>&nbsp;</td>";
                         echo "<td><input type=\"checkbox\" name=\"dns-whitelist-entry-activ[$count]\" value=\"1\" $checked></td>";
                         echo "<td><input type=\"text\" size=\"50\" name=\"dns-whitelist-entry[$count]\" value=\"$val\"></td>";
                         echo "</tr>";
                         $count++;
                         }
                      }
               }

      function getOtherSettings($conf){

               $count = 1;
               while (list($key, $val) = each($conf)){
                      $found = array_search(trim(str_replace("#","",$key)),$this->otherSettings);
                      if($found > -1){
                         $checked = stristr($key,"#")?"":"checked";
                         echo "<tr>";
                         echo "<td>&nbsp;</td>";
                         echo "<td><input type=\"checkbox\" name=\"conf-others[$count]\" value=\"$key\" $checked></td>";
                         echo "<td>".constant("SCP_ALLG_SPAMDYKE_OTHER_".strtoupper(str_replace("#","",$key)))."</td>";
                         echo "</tr>";
                         $count++;
                         unset($this->otherSettings[$found]);
                         }
                      }
               sort($this->otherSettings);
               for($r=0;$r<count($this->otherSettings);$r++){
                   echo "<tr>";
                   echo "<td>&nbsp;</td>";
                   echo "<td><input type=\"checkbox\" name=\"conf-others[$count]\" value=\"".$this->otherSettings[$r]."\"></td>";
                   echo "<td>".constant("SCP_ALLG_SPAMDYKE_OTHER_".strtoupper($this->otherSettings[$r]))."</td>";
                   echo "</tr>";
                   $count++;
                   }

               }
               
      function viewAdmPart($part){
      	       echo '<script type="text/javascript">';
      	       if(!empty($part)){
      	       	  echo 'adminView(\''.$part.'\');';
      	       	  }
      	       echo 'ermittlePids();';
	       echo '</script>';
      	       }
      	
      function actSpamdykeProc($kill=false){
      	
      	       if($kill){
      	          exec('./wrapper "1" "killallspamdyke"');
      	       }else{      	        
      	          exec('ps -ef | grep spamdyke', $out); 
      	          echo count($out);
      	          }
      	       }

     function getSpamdykeVer(){
              exec('./wrapper "1" "spamdykeversion"',$out);
              echo $out[0];
              }
      	       
     function viewAllDomains(){
     	      $tmpDom = $this->dieDomain;
     	      $res = mysql_query("SELECT name FROM psa.domains");
     	      $c = 0;
     	      while($data = mysql_fetch_object($res)){
     	      	   $farbe = ($c%2)?"bgcolor='#CCCCCC'":"";
     	      	   echo '<tr '.$farbe .'>';
     	      	   echo '<td><a href="javascript:toggleDomain(\''.$data->name.'\')"><img src="toggleAllNone.gif" border="0" alt="'.SCP_ADMIN_ALLNONE_SELECTION.'" title="'.SCP_ADMIN_ALLNONE_SELECTION.'"></a></td>';
     	      	   echo '<td>'.$data->name.'</td>';
     	      	   echo '<td colspan="2">'.$this->getDomainRightMulti($data->name,'gl').'</td>';
     	      	   echo '<td colspan="2">'.$this->getDomainRightMulti($data->name,'live').'</td>';
     	      	   echo '<td colspan="2">'.$this->getDomainRightMulti($data->name,'ip').'</td>';
     	      	   echo '<td colspan="2">'.$this->getDomainRightMulti($data->name,'sender').'</td>';
     	      	   echo '<td colspan="2">'.$this->getDomainRightMulti($data->name,'recipient').'</td>';
     	      	   echo '<td colspan="2">'.$this->getDomainRightMulti($data->name,'rdns').'</td>';
     	      	   echo '<td colspan="2">'.$this->getDomainRightMulti($data->name,'keywords').'</td>';
     	      	   $c++;
     	      	   }
     	      }
     	      
     function updateReportSettings($post){
     	
     	      $psa = substr($this->scriptFolder,0,strpos($this->scriptFolder,"admin")+5)."/bin/php";
     	      
     	      $chmod = substr($this->scriptFolder,0,strlen($this->scriptFolder)-1);
     	      $cron = $psa.' dailyreport.php';
     	
     	      if($this->isReportOn != $post["report_on"]){
     	      	 $on = ($post["report_on"])?"on":"off";
     	      	 exec('./wrapper "1" "reports_'.$on.'" "'.$chmod.'" "'.$cron.'"');
     	      	 $this->isReportOn = $post["report_on"];
     	         }
     	         
     	         
     	         
     	         
     	         
     	       
     	      $rechte["admin"] = $this->reportStates["admin"];
     	      $rechte["user"] = $this->reportStates["user"];
     	      
     	         
     	      if((is_array($this->reportStates["admin"]) != $post["report_admin"]) || $_POST["report_admin_email"] != $rechte["admin"][0]){
      	      	 $rechte["admin"] = false;
     	      	 if($post["report_admin"])$rechte["admin"] = array($_POST["report_admin_email"]);
     	      	 $this->reportStates["admin"] = $rechte["admin"];
     	      	 }
     	
     	      if(is_array($this->reportStates["user"]) != $post["report_user"]){
     	      	 $rechte["user"] = false;
     	      	 if($post["report_user"])$rechte["user"] = array();
     	      	 $this->reportStates["user"] = $rechte["user"];
     	      	 }
     	      	 
     	      $this->schreibeReportRechte();
     	
              } 
              
      function updateAbuseSettings($post){
      	       $this->abuseDetails = $post["spam-abuse"];
      	       $this->schreibeAbuseRechte();
      	       }
      	       
      function isSpamReport(){
      	
      	       if(empty($this->abuseDetails["sender"]) ||
        	  empty($this->abuseDetails["titel"]) ||
        	  empty($this->abuseDetails["template"])) return 0;
        	  
               return 1;	  
      	
      	       }

      function sendSpamReport($data){
               if(!$this->isSpamReport()){
                  echo "NO RIGHTS TO SEND AN ABUSE MAIL!";
                  exit;
                  }
             
               $spamline = "==============================================\n";
               $spamline.= "FROM: ".$data["from"]."\n";
               $spamline.= "TO: ".$data["to"]."\n";
               $spamline.= "IP: ".$data["ip"]."\n";
               $spamline.= "RDNS: ".$data["rdns"]."\n";
               $spamline.= "TIMESTAMP: ".$data["stamp"]."\n";
               $spamline.= "==============================================";

               $nachricht = str_replace("{SPAMLINE}",$spamline,$this->abuseDetails["template"]);
               $header = 'From: '.$this->abuseDetails["sender"]. "\r\n";
               $header.= 'Reply-To: '.$this->abuseDetails["sender"]. "\r\n";
               $header.= 'Bcc: '.$this->abuseDetails["sender"]. "\r\n";
               $header.= 'SCP2[haggybear.de]/X-Mailer: PHP/' . phpversion();

               $isSend = mail($data["rec"], $this->abuseDetails["titel"], $nachricht, $header);

               if(!$isSend){
                 echo "ERROR WHILE SENDING THE MAIL!";
                 exit;
                 }

               echo "emailwassend";

               }

     }













?>