<?php
/*
Plesk Spamdyke Control Panel (Version see version.php) - GUI for Plesk spamdyke implementation

Copyright (C) [2008] [Matthias Hackbarth / www.haggybear.de]

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as 
published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; if not, see <http://www.gnu.org/licenses/>.
*/

@ini_set("memory_limit",'256M'); 
require("./config.inc.php");
if(PSA_VERSION > 8) apc_clear_cache();
require("./version.php");
require("./lang/".LANG.".inc.php");
require("./scp.class.php");

$action = "main";

if($_GET["action"] != "") $action = $_GET["action"];

$scp = scp::factory($session, $_GET, array(DB_HOST,DB_NAME,DB_USR,DB_PWD));
$scp->feProps('filter,rechte,einstellungen');

if(file_exists("./config.new.txt") && !isset($_GET["action"]) && $scp->plesk_session->chkLevel(IS_ADMIN) && AUTOUPDATE){
   header("Location: index.php?".$_SERVER["QUERY_STRING"]."&action=update");
  }

if(!empty($_POST["suchmuster"]) || isset($_POST["savelist"])){
$scp->suchmuster = $_POST["suchmuster"];
$scp->anzVars["anz_PerPage"] = $_POST["anz_PerPage"];
$scp->anzVars["anz_LiveCountry"] = $_POST["anz_LiveCountry"];
$scp->anzVars["anz_Von"] = $_POST["anz_Von"];
$scp->anzVars["anz_Filter"] = $_POST["anz_Filter"];
$scp->anzVars["anz_Richtung"] = $_POST["anz_Richtung"];
$scp->anzVars["anz_GlPaar"] = $_POST["anz_GlPaar"];
}

if($action == "abusemail"){
$scp->getAdmin()->sendSpamReport($_POST);
exit;
}

if($_GET["todo"] == "anzeige"){
$scp->anzVars = $_POST;
}

if($action == "admin"){
  if(!$scp->plesk_session->chkLevel(IS_ADMIN)) $action == "main";
 
    if(isset($_POST["e_handler"])){
       $scp->getAdmin()->setEventHandler($scp->spamDykeConf,$_POST);
       }

    if(isset($_POST["spamdyke_conf"])){
       $scp->getAdmin()->setSpamDykeConf($scp->spamDykeConf,$_POST);
       $scp->setSpamDykeConf();
       $scp->getAdmin()->updateRechteMulti($_POST);
       $scp->getAdmin()->updateReportSettings($_POST);
       $scp->getAdmin()->updateAbuseSettings($_POST);
       }
       
    if(isset($_POST["killspamdyke"])){
       $scp->getAdmin()->actSpamdykeProc(true);
       }

   }

if($action == "allview"){
  if($scp->plesk_session->chkLevel(IS_ADMIN)) $scp->getAdmin()->isAllView = true;
 
    $action = "main";
   }


if($action == "main"){
   $scp->readQmailLogs();
   $scp->readList("ip-whitelist");
   $scp->readList("ip-blacklist");
   $scp->readList("rdns-whitelist");
   $scp->readList("rdns-blacklist");
   $scp->readList("sender-whitelist");
   $scp->readList("sender-blacklist");
   $scp->readList("recipient-whitelist");
   $scp->readList("recipient-blacklist");
   $scp->readList("ip-in-rdns-keyword-blacklist");
   }

$scp->setQueryString($_SERVER["QUERY_STRING"]);

if(!$scp->getPleskAllowed()){
    //alert(lmsg('__perm_denied'));
    go_to_uplevel();
   }

if(isset($_POST["savelist"])){
$scp->setAllLists($_POST);
}



if($scp->plesk_session->chkLevel(IS_ADMIN) && !empty($_POST["adminsave"])){
   $scp->dieRechte->updateRechte("gl",$_POST["gl"]);
   $scp->dieRechte->updateRechte("live",$_POST["live"]);
   $scp->dieRechte->updateRechte("ip",$_POST["ip"]);
   $scp->dieRechte->updateRechte("sender",$_POST["sender"]);
   $scp->dieRechte->updateRechte("rdns",$_POST["rdns"]);
   $scp->dieRechte->updateRechte("keywords",$_POST["keywords"]);
   $scp->dieRechte->updateRechte("recipient",$_POST["recipient"]);
   $scp->dieRechte->schreibeRechte();
   }

$scp->getAllBlocked();

if($_POST["doexport"]){
   $scp->doExport();
   }
?>
<html>
<head>
<link rel="shortcut icon" href="/favicon.ico">
<title>Spamdyke Contron Panel</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
<script language="javascript" type="text/javascript" src="/javascript/common.js"></script>
<script language="javascript" type="text/javascript" src="/javascript/chk.js.php"></script>
<script language="javascript" type="text/javascript" src="jquery.js"></script>
<link rel="stylesheet" type="text/css" href="/skins/<?php echo $scp->getPleskSkin();?>/css/general.css">
<link rel="stylesheet" type="text/css" href="/skins/<?php echo $scp->getPleskSkin();?>/css/main/custom.css">
<link rel="stylesheet" type="text/css" href="/skins/<?php echo $scp->getPleskSkin();?>/css/main/layout.css">
<link rel="stylesheet" type="text/nonsense" href="/skins/<?php echo $scp->getPleskSkin();?>/css/misc.css">
<link rel="stylesheet" type="text/css" href="<?php echo (eregi("msie",$_SERVER["HTTP_USER_AGENT"]))?"doof":"schlau";?>_browser.css">
<style type="text/css">
<!--
#topStatBody td {vertical-align: top}
-->
</style>

<script type="text/javascript">
<!--

InitTips('/javascript/conhelp.js.php','plesk-base');

var opt_no_frames = false;
var opt_integrated_mode = false;
var stats_top_generated = false;

function toggleDirectList(id,inOut){
         
         if(inOut){
            document.getElementById(id).className='vis'
            document.getElementById(id).style.border = "1px solid #000000";
            }
         else{
            document.getElementById(id).className='invis'
            document.getElementById(id).style.border = "none";
           }

         }

function _body_onload()
{
        loff();
        SetContext('<?php echo SCP_ADMIN;?>');
			
}
			
function _body_onunload()
{
        lon();
				
}
				
		
function toggleScreen(what)
{

if(document.all){
   document.getElementById(what).style.marginTop = -240 + (document.body.scrollTop);
   window.onscroll = function(){document.getElementById(what).style.marginTop = -240 + (document.body.scrollTop);}
   }

if(document.getElementById(what).style.display != "block"){
  $("#fader").fadeIn("fast",function(){$("#"+what).fadeIn("fast");});
  }
else{
  if(document.all)window.onscroll = null;
   
  $("#"+what).fadeOut("fast",function(){$("#fader").fadeOut("fast");});
 
}

}

function toggleStats(inFade,outFade){
          yn = true;
          blocked = "<?php echo $scp->blocked;?>";
          mins = blocked/500/60;
          if(mins>1){
            mins = Math.round(mins);
          }else{
           mins = mins.toFixed(2);
           }
          mess = "<?php echo SCP_TAKES_LONG_TO_GENERATE;?>";
          mess = mess.replace(/#IPS#/,blocked);
          mess = mess.replace(/#MIN#/,mins);
          if(blocked > 50 && !stats_top_generated) yn = window.confirm(unescape(mess));
          jn = (yn)?1:0;

         $("#"+outFade).fadeOut();
         $("#"+inFade).fadeIn("fast",function(){

         if(inFade == "topStat" && !stats_top_generated){
          
            von = document.anzeige.anz_Von.value;

            $("#topStat").load("topstat.php?<?php $scp->getQueryString(); ?>&todo=anzeige<?php echo ($scp->getAdmin()->isAllView)?"&action=allview":"";?>", {anzeige:von,land:jn},function(){
             stats_top_generated = true;
             });}
          });
           

         }

function setWhite(what,ip){

         myDom = document.getElementById(what);
         col = myDom.getElementsByTagName('textarea');
         for(i=0;i<col.length;i++){
             if(col[i].name == "whitelist"){

                if(col[i].value.indexOf(ip) >= 0){
                   alert("<?php echo SCP_ON_WHITELIST;?>");
                   return;
                   }

                if(col[i].value != ""){
                   col[i].value = col[i].value + "\n"+ip;
                   }
                else{
                 col[i].value = ip;
                }
               }
            }
         toggleScreen(what);
         }
         
function setBlack(what,ip){

         myDom = document.getElementById(what);
         col = myDom.getElementsByTagName('textarea');
         for(i=0;i<col.length;i++){
             if(col[i].name == "blacklist"){

                if(col[i].value.indexOf(ip) >= 0){
                   alert("<?php echo SCP_ON_BLACkLIST;?>");
                   return;
                   }

                if(col[i].value != ""){
                   col[i].value = col[i].value + "\n"+ip;
                   }
                else{
                   col[i].value = ip;
                  }
              }
           } 
         toggleScreen(what);
         }

function getPageContent(strURL,IP,what) {
    toggleScreen('iplook');
    var xmlHttpReq = false;
    
    var header_box = "<?php echo GETTING_IP_INFO;?>";

    if(what == "mail") header_box = "<?php echo CHECKING_EMAIL;?>";
    
    <?php if($scp->plesk_session->chkLevel(IS_ADMIN)):?>
    if(what == "ip") strURL+="&abuse=<?php echo $scp->getAdmin()->isSpamReport();?>";
    <?php endif;?>

     
    var loadContent = '<table width="600" height="250" border="0" cellpadding="0" cellspacing="0"><tr>'
                    + '<td align="center" valign="middle"><b>'+header_box+' ('+IP+')</b></td></tr><tr>'
                    + '<td align="center" valign="middle"><img src="loading.gif" width="225" height="225"></td></tr></table>'
    
							    
    var self = this;

    // Mozilla/Safari
    if (window.XMLHttpRequest) {
       windowPos = window.pageYOffset;
       self.xmlHttpReq = new XMLHttpRequest();
       }
    
    // IE
    else if (window.ActiveXObject) {
        windowPos = document.body.scrollTop;
        self.xmlHttpReq = new ActiveXObject("Microsoft.XMLHTTP");
        }
	
    updatepage(loadContent);
    
    self.xmlHttpReq.open('GET', strURL, true);
    
    self.xmlHttpReq.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
    
    self.xmlHttpReq.onreadystatechange = function() {
    if (self.xmlHttpReq.readyState == 4) {
        updatepage(self.xmlHttpReq.responseText);
        }
    }
    
    self.xmlHttpReq.send(null);
    
}
function updatepage(str){
    document.getElementById("iplook_content").innerHTML = str;
    }

function adminView(id){
         views = Array(<?php echo $scp->getAdmin()->regKarten;?>);
         for(i=0;i<views.length;i++){
            if(document.getElementById(views[i]).style.display != "none"){
               wer = views[i];
               break;
               }
            }
         $("#"+wer).fadeOut("fast",function(){
         $("#"+id).fadeIn("fast");});

         document.scpedit.saveAdmView.value = id;
         ermittlePids();
         }
         
function viewPart(part){
         $("#"+part).slideToggle("slow",function(){
           tf = (document.getElementById(part).style.display == "none")?false:true;
           if(tf){
              document.getElementById(part+"_lnk").className = "bold";
              }
           else{
             document.getElementById(part+"_lnk").className = "";
             }
          storeValues();
         });
         }
         
function storeValues(){
	 
	 vals = new Array("einstellungen_fe","filter_fe"<?php echo ($scp->plesk_session->chkLevel(IS_ADMIN))?',"rechte_fe"':'';?>);
	 
	 for(i=0;i<vals.length;i++){
	     tf = (document.getElementById(vals[i]).style.display != "none")?true:false;
	     if(tf){
	        document.cookie = vals[i]+"=block:bold";
	     }else{
	        document.cookie = vals[i]+"=none:normal";
	        }
	    }
	 }
	 
function changeDailyRep(val){
	
	 if(val>0){
	    status = window.prompt("Bitte geben Sie die Empfänger-Adresse für den täglichen Report an");
	    }
	 else{
	    status = 0;
	    }
	
	 document.scpedit.isdailyreport.value = status;
	 document.scpedit.submit()
	
	 }

function resetFilter(){
         filterTags = document.getElementById("filter_fe").getElementsByTagName("select");
         for(i=0;i<filterTags.length;i++){
            alleTags = document.getElementsByName(filterTags[i].name);
            for(ii=0;ii<alleTags.length;ii++){
                if(alleTags[ii].type=="hidden"){
                   alleTags[ii].value = "";
                  }
                else{
                   alleTags[ii].selectedIndex = 0;
                 }
               }
            
            }

         suchTags = document.getElementsByName("suchmuster");
         for(i=0;i<suchTags.length;i++){
            suchTags[i].value = "";
            }
         }

function doExport(){
         document.suchenf.doexport.value = "1";
         document.suchenf.submit();
         }
         
function abuseReport(vals,email){
	
	 yn = window.confirm(unescape("<?php echo SCP_SPAM_ABUSE_REPORT_DO;?>"));
	 if(!yn) return;

	 dieRows = document.getElementById("log_table").getElementsByTagName("tr");
	 dieTds = dieRows[(Number(vals)+1)].getElementsByTagName("td");
	 from = dieTds[2].getAttribute('title');
 	 to = dieTds[3].getAttribute('title');
 	 ip = dieTds[5].getAttribute('title');
	 rdns = dieTds[6].getAttribute('title');
	 stamp = dieTds[7].innerHTML;
	 
	 
	 $.post("index.php?<?php $scp->getQueryString(); ?>&action=abusemail",{ rec:email, from: from, to: to, ip: ip, rdns: rdns,stamp: stamp }, function(data){
           if(data.indexOf("emailwassend")>-1){
              yn = window.confirm("<?php echo SCP_SPAM_ABUSE_REPORT_DO_OK;?>");
              if(yn) toggleScreen('iplook');
              }
           else{
             alert("<?php echo SCP_SPAM_ABUSE_REPORT_DO_NOK;?>"+data);
             }
           });

	 }         
//-->
</script>
</head>
<body onLoad="_body_onload();" onUnload="_body_onunload();" id="mainCP" class="">

<div id="fader" class="invis"></div>
<div id="content">
<?php if(PSA_VERSION < 9):?>
    <div class="pathbar"><a href="/domains/domains.php3" onclick="lon();">Domains</a> &gt; <a href="/domains/dom_ctrl.php3" onclick="lon();"><?php echo $_GET["dom_name"];?></a> &gt;</div>
	<div class="screenTitle">
  	 <table cellspacing="0" width="100%">
	  <tbody>
	   <tr>
	    <td><?php echo SCP_ADMIN;?> Domain <span class="name"><?php $scp->getAllowedDoms();?></span></td>
	    <td class="uplevel"><div class="commonButton" id="bid-up-level" title="back" onclick="lon();go_to('/domains/dom_ctrl.php3?previous_page=subdomains'); return false;" onmouseover="mouse_move('b_to_dom_ctrl')" onmouseout="mouse_move()"><button name="bname_up_level"><?php echo SCP_LEVEL_UP;?></button><span><?php echo SCP_LEVEL_UP;?></span></div></td>
	   </tr>
	 </tbody>
	 </table>
	</div>
<?php else:?>	
    <div class="pathbar"><a href="/domains/domains.php3" onclick="lon();">Domains</a> &gt; <a href="/domains/dom_ctrl.php3" onclick="lon();"><?php echo $_GET["dom_name"];?></a> &gt;</div>
	<div class="screenTitle">
          <table cellspacing="0" width="100%">
          <tbody>
          <tr>
            <td class="title"><div class='titleContainer clear'><h1><?php echo SCP_ADMIN;?> Domain <span class="name"><?php echo $_GET["dom_name"];?></span></h1></div>
	    </td>
            <td class="toolbar">
	    <div class="toolbarWrapper">
	    <div class="toolbarItems">
	    <table cellspacing="0">
	    <tr>  
	    <td><div class="toolbarBtn" id="bid-up-level"><A name="up_level" id="up_level" href="/domains/dom_ctrl.php3?previous_page=subdomains" onClick=";lon();"><span><?php echo SCP_LEVEL_UP;?></span></a></div></td></tr>
           </table>	
         </div>
       </div>	
    </td>
  </tr>
 </tbody>
 </table>
</div>	
<?php endif;?>	
<table width="100%"  border="0" cellspacing="0" cellpadding="2">
  <tr>
   <td>&nbsp;</td>
   <td>&nbsp;</td>
  </tr>
  <tr>
   <td width="5%" align="center" bgcolor="#DDDDDD"><img src="dslogo.gif" width="32" height="32"></td>
   <td width="50%" bgcolor="#DDDDDD"><strong>Spamdyke Control Panel Version (<?php echo SCP_VERSION;?>-<?php echo LOG_TYPE;?>)</strong>
		            &nbsp; &nbsp; [<?php $scp->checkVersion(SCP_VERSION);?>] </td>
   
   <td width="25%" bgcolor="#DDDDDD" align="center"><?php if($action != "admin"):?><input type="button" onClick="resetFilter()" value="<?php echo SCP_RESETFILTER;?>">&nbsp;<input type="button" onClick="document.anzeige.submit()" value="<?php echo SCP_REFRESH;?>"><?php endif;?></td>
   <td width="25%" bgcolor="#DDDDDD" align="right">
<form name="suchenf" method="post" action="index.php?<?php $scp->getQueryString(); ?>&todo=anzeige<?php echo ($scp->getAdmin()->isAllView)?"&action=allview":"";?>">
        <input type="text" name="suchmuster" value="<?php echo $_POST["suchmuster"];?>" size="15">
        <input type="submit" name="jetztsuchen" value="<?php echo SCP_SEARCH_DO;?>">
        <input type="hidden" name="anz_PerPage" value="<?php echo $scp->anzVars["anz_PerPage"];?>">
        <input type="hidden" name="anz_Richtung" value="<?php echo $scp->anzVars["anz_Richtung"];?>">
        <input type="hidden" name="anz_LiveCountry" value="<?php echo $scp->anzVars["anz_LiveCountry"];?>">
        <input type="hidden" name="anz_Von" value="<?php echo $scp->anzVars["anz_Von"];?>">
        <input type="hidden" name="anz_Filter" value="<?php echo $scp->anzVars["anz_Filter"];?>">
        <input type="hidden" name="anz_GlPaar" value="<?php echo $scp->anzVars["anz_GlPaar"];?>">
        <input type="hidden" name="doexport" value="0">
</form>
      </td>
  </tr>
</table>
			      								
<?php 

if($scp->spamDykeInstalled){
   include("./".$action.".php");
}else{
   include("./nodyke.php");
}

?>
</div>
</body>
</html>